"use strict";
/**
 * @prettier
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.startServer = exports.KoaRuntimeResponse = void 0;
const tslib_1 = require("tslib");
const cors_1 = tslib_1.__importDefault(require("@koa/cors"));
const koa_1 = tslib_1.__importDefault(require("koa"));
const koa_body_1 = tslib_1.__importDefault(require("koa-body"));
class KoaRuntimeResponse {
    status;
    _body;
    constructor(status) {
        this.status = status;
    }
    body(body) {
        this._body = body;
        return this;
    }
    unpack() {
        return { status: this.status, body: this._body };
    }
}
exports.KoaRuntimeResponse = KoaRuntimeResponse;
async function startServer({ middleware = [], cors = undefined, body = undefined, port = 0, router, }) {
    const app = new koa_1.default();
    if (cors !== false) {
        app.use((0, cors_1.default)(cors));
    }
    if (body !== false) {
        app.use((0, koa_body_1.default)(body));
    }
    middleware.forEach((it) => app.use(it));
    app.use(router.allowedMethods());
    app.use(router.routes());
    return new Promise((resolve) => {
        const server = app.listen(port, () => {
            const address = server.address();
            if (!address || typeof address !== "object") {
                throw new Error("failed to bind port");
            }
            resolve({ app, server, address });
        });
    });
}
exports.startServer = startServer;
//# sourceMappingURL=server.js.map